<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\ProductionPlan;
use App\Models\User;

class ProductionPlanPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any ProductionPlan');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, ProductionPlan $productionplan): bool
    {
        return $user->checkPermissionTo('view ProductionPlan');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create ProductionPlan');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, ProductionPlan $productionplan): bool
    {
        return $user->checkPermissionTo('update ProductionPlan');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, ProductionPlan $productionplan): bool
    {
        return $user->checkPermissionTo('delete ProductionPlan');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any ProductionPlan');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, ProductionPlan $productionplan): bool
    {
        return $user->checkPermissionTo('restore ProductionPlan');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any ProductionPlan');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, ProductionPlan $productionplan): bool
    {
        return $user->checkPermissionTo('replicate ProductionPlan');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder ProductionPlan');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, ProductionPlan $productionplan): bool
    {
        return $user->checkPermissionTo('force-delete ProductionPlan');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any ProductionPlan');
    }
}
